﻿using System;
using System.Collections;
using System.Data;
using System.Data.Common;
using System.Configuration;
using System.Collections.Generic;
using System.Web;
using System.Web.Security;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public class Cart {

    public string Isbn {get; set;}
    public string Title {get; set;}
    public int Price {get; set;}
    public int Quantity {get; set;}    
    public int SubTotal {get; set;}

    public List<Cart> GetCartInfo() {
        var list = new List<Cart>();
        var Context  = HttpContext.Current;
        var Session = Context.Session;
        for(int i = 0; i < Session.Count; i++) { 
            var crt = new Cart();
            crt.Isbn = Session.Keys[i];
            crt.Quantity = (int)(Session[i]);
            var setting = ConfigurationManager.ConnectionStrings["MyDB"];
            var factory = DbProviderFactories.GetFactory(setting.ProviderName);
            using(var db = factory.CreateConnection()) {
                db.ConnectionString = setting.ConnectionString;
                var comm  = factory.CreateCommand();
                comm.CommandText = 
                  "SELECT title, price FROM Book WHERE isbn=@isbn";
                comm.Connection = db;
                var param = factory.CreateParameter();
                param.ParameterName = "@isbn";
                param.Value = crt.Isbn;
                comm.Parameters.Add(param);
                db.Open();
                var reader = comm.ExecuteReader();
                if(reader.Read()) {
                    crt.Title = reader.GetString(0);
                    crt.Price = reader.GetInt32(1);
                    crt.SubTotal = crt.Price * crt.Quantity;
                    list.Add(crt);
                }
            }
        }
        return list;
    }

    public void DeleteCartInfo(Cart crt) {
        var Context = HttpContext.Current;
        var Session = Context.Session;
        Session.Remove(crt.Isbn);
    }
    
    public void InsertCartInfo() {
        var Context = HttpContext.Current;
        var Session = Context.Session;
        var setting = ConfigurationManager.ConnectionStrings["MyDB"];
        var factory = DbProviderFactories.GetFactory(setting.ProviderName);
        using (var db = factory.CreateConnection()) {
            db.ConnectionString = setting.ConnectionString;
            var comm = factory.CreateCommand();
            comm.CommandText = 
              "INSERT INTO OrderInfo(uid,isbn,quantity) VALUES(@uid, @isbn, @quantity)";
            comm.Connection = db;
            db.Open();
            for(int i=0;i<Session.Count;i++){
                comm.Parameters.Clear();
                var pUid = factory.CreateParameter();
                pUid.ParameterName = "@uid";
                pUid.Value = Context.User.Identity.Name;
                comm.Parameters.Add(pUid);
                var pIsbn = factory.CreateParameter();
                pIsbn.ParameterName = "@isbn";
                pIsbn.Value = Session.Keys[i];
                comm.Parameters.Add(pIsbn);
                var pQuantity = factory.CreateParameter();
                pQuantity.ParameterName = "@quantity";
                pQuantity.Value = Session[i];
                comm.Parameters.Add(pQuantity);
                comm.ExecuteNonQuery();
            }
        }
    }
}