﻿using System;
using System.Data;
using System.Data.Common;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public class LoggingModule : IHttpModule {
    public void Init(HttpApplication Application) {
        Application.BeginRequest += (new EventHandler(this.Application_BeginRequest));
    }

    public void Application_BeginRequest(Object sender, EventArgs e) {
        var ctx = ((HttpApplication)sender).Context;
        var setting = ConfigurationManager.ConnectionStrings["MyDB"];
        var factory = DbProviderFactories.GetFactory(setting.ProviderName);
        using (var db = factory.CreateConnection()) {
            db.ConnectionString = setting.ConnectionString;
            var comm = factory.CreateCommand();
            comm.CommandText = "INSERT INTO LogInfo(url,userAgent,accessTime) VALUES(@url,@userAgent,@accessTime)";
            comm.Connection = db;
            var pUrl = factory.CreateParameter();
            pUrl.ParameterName = "@url";
            pUrl.Value = ctx.Request.Url.ToString();
            comm.Parameters.Add(pUrl);
            var pAgent = factory.CreateParameter();
            pAgent.ParameterName = "@userAgent";
            pAgent.Value = ctx.Request.UserAgent;
            comm.Parameters.Add(pAgent);
            var pAccess = factory.CreateParameter();
            pAccess.ParameterName = "@accessTime";
            pAccess.Value = DateTime.Now.ToString();
            comm.Parameters.Add(pAccess);
            db.Open();
            comm.ExecuteNonQuery();
        }
    }

    public void Dispose() {}
}