﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Day02/MyMaster.master" %>

<script runat="server">
    protected void grid_RowCreated(Object sender , GridViewRowEventArgs e) {
        if(e.Row.RowType == DataControlRowType.Footer) {
            var ltr = new LiteralControl("総ページ数：" + grid.PageCount);
            var cell = e.Row.Cells[e.Row.Cells.Count - 1];
            cell.HorizontalAlign = HorizontalAlign.Right;
            cell.Wrap = false;
            cell.Controls.Add(ltr);
        }
    }
</script>

<asp:Content ID="Content1" ContentPlaceHolderID="head" Runat="Server">
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="cph" Runat="Server">
    <asp:GridView ID="grid" runat="server" AllowPaging="True" AllowSorting="True" 
        AutoGenerateColumns="False" CellPadding="4" DataKeyNames="isbn" 
        DataSourceID="sds" ForeColor="#333333" GridLines="None" PageSize="5" 
        ShowFooter="True" OnRowCreated="grid_RowCreated">
        <RowStyle BackColor="#FFFBD6" ForeColor="#333333" />
        <Columns>
            <asp:HyperLinkField DataNavigateUrlFields="isbn" 
                DataNavigateUrlFormatString="http://www.wings.msn.to/index.php/-/A-03/{0}/" 
                DataTextField="isbn" DataTextFormatString="{0}" HeaderText="ISBNコード" />
            <asp:TemplateField HeaderText="書名" SortExpression="title">
                <EditItemTemplate>
                    <asp:TextBox ID="txtTitle" runat="server" Columns="30" MaxLength="100" 
                        Text='<%# Bind("title") %>'></asp:TextBox>
                </EditItemTemplate>
                <ItemTemplate>
                    <asp:Label ID="Label1" runat="server" Text='<%# Bind("title") %>'></asp:Label>
                </ItemTemplate>
            </asp:TemplateField>
            <asp:TemplateField HeaderText="価格" SortExpression="price">
                <EditItemTemplate>
                    <asp:TextBox ID="txtPrice" runat="server" Columns="7" MaxLength="10" 
                        Text='<%# Bind("price") %>'></asp:TextBox>
                    円
                </EditItemTemplate>
                <ItemTemplate>
                    <asp:Label ID="Label2" runat="server" Text='<%# Bind("price", "{0:#,###円}") %>'></asp:Label>
                </ItemTemplate>
            </asp:TemplateField>
            <asp:TemplateField HeaderText="出版社" SortExpression="publish">
                <EditItemTemplate>
                    <asp:DropDownList ID="ddlPublish" runat="server" DataSourceID="sdsPublish" 
                        DataTextField="publish" DataValueField="publish" 
                        SelectedValue='<%# Bind("publish") %>'>
                    </asp:DropDownList>
                    <asp:SqlDataSource ID="sdsPublish" runat="server" 
                        ConnectionString="<%$ ConnectionStrings:MyDB %>" 
                        SelectCommand="SELECT DISTINCT [publish] FROM [Book]"></asp:SqlDataSource>
                </EditItemTemplate>
                <ItemTemplate>
                    <asp:Label ID="Label3" runat="server" Text='<%# Bind("publish") %>'></asp:Label>
                </ItemTemplate>
            </asp:TemplateField>
            <asp:TemplateField HeaderText="発売日" SortExpression="published">
                <EditItemTemplate>
                    <asp:TextBox ID="txtPublished" runat="server" 
                        Text='<%# Bind("published", "{0:yyyy/MM/dd}") %>' Columns="15" 
                        MaxLength="10"></asp:TextBox>
                </EditItemTemplate>
                <ItemTemplate>
                    <asp:Label ID="Label4" runat="server" 
                        Text='<%# Bind("published", "{0:yyyy年MM月dd日}") %>'></asp:Label>
                </ItemTemplate>
            </asp:TemplateField>
            <asp:CheckBoxField DataField="cdrom" HeaderText="CD-ROM" 
                SortExpression="cdrom" />
            <asp:ImageField DataAlternateTextField="title" DataImageUrlField="isbn" 
                DataImageUrlFormatString="http://www.wings.msn.to/books/{0}/{0}.jpg" 
                HeaderText="表紙" ReadOnly="True">
                <ControlStyle Height="48px" Width="35px" />
            </asp:ImageField>
            <asp:TemplateField ShowHeader="False">
                <EditItemTemplate>
                    <asp:Button ID="Button1" runat="server" CausesValidation="True" 
                        CommandName="Update" Text="更新" />
                    &nbsp;<asp:Button ID="Button2" runat="server" CausesValidation="False" 
                        CommandName="Cancel" Text="キャンセル" />
                </EditItemTemplate>
                <ItemTemplate>
                    <asp:Button ID="Button1" runat="server" CausesValidation="False" 
                        CommandName="Edit" Text="編集" />
                    &nbsp;<asp:Button ID="Button2" runat="server" CausesValidation="False" 
                        CommandName="Delete" onclientclick="return confirm(&quot;削除してもよろしいですか？&quot;)" 
                        Text="削除" />
                </ItemTemplate>
            </asp:TemplateField>
        </Columns>
        <FooterStyle BackColor="#990000" Font-Bold="True" ForeColor="White" />
        <PagerStyle BackColor="#FFCC66" ForeColor="#333333" HorizontalAlign="Center" />
        <SelectedRowStyle BackColor="#FFCC66" Font-Bold="True" ForeColor="Navy" />
        <HeaderStyle BackColor="#990000" Font-Bold="True" ForeColor="White" />
        <AlternatingRowStyle BackColor="White" />
    </asp:GridView>
    <asp:SqlDataSource ID="sds" runat="server" 
        ConnectionString="<%$ ConnectionStrings:MyDB %>" 
        DeleteCommand="DELETE FROM [Book] WHERE [isbn] = @isbn" 
        InsertCommand="INSERT INTO [Book] ([isbn], [title], [price], [publish], [published], [cdrom]) VALUES (@isbn, @title, @price, @publish, @published, @cdrom)" 
        SelectCommand="SELECT [isbn], [title], [price], [publish], [published], [cdrom] FROM [Book]" 
        UpdateCommand="UPDATE [Book] SET [title] = @title, [price] = @price, [publish] = @publish, [published] = @published, [cdrom] = @cdrom WHERE [isbn] = @isbn">
        <DeleteParameters>
            <asp:Parameter Name="isbn" Type="String" />
        </DeleteParameters>
        <UpdateParameters>
            <asp:Parameter Name="title" Type="String" />
            <asp:Parameter Name="price" Type="Int32" />
            <asp:Parameter Name="publish" Type="String" />
            <asp:Parameter DbType="Date" Name="published" />
            <asp:Parameter Name="cdrom" Type="Boolean" />
            <asp:Parameter Name="isbn" Type="String" />
        </UpdateParameters>
        <InsertParameters>
            <asp:Parameter Name="isbn" Type="String" />
            <asp:Parameter Name="title" Type="String" />
            <asp:Parameter Name="price" Type="Int32" />
            <asp:Parameter Name="publish" Type="String" />
            <asp:Parameter DbType="Date" Name="published" />
            <asp:Parameter Name="cdrom" Type="Boolean" />
        </InsertParameters>
    </asp:SqlDataSource>
</asp:Content>

