﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Day02/MyMaster.master" %>
<%@ Import Namespace="System.Data.Common" %>

<script runat="server">

    protected void cal_DayRender(Object sender, DayRenderEventArgs e) {
        var setting = ConfigurationManager.ConnectionStrings["MyDB"];
        var factory = DbProviderFactories.GetFactory(setting.ProviderName);
        using(var db = factory.CreateConnection()) {
            db.ConnectionString = setting.ConnectionString;
            var comm = factory.CreateCommand();
            comm.CommandText = "SELECT sid,subject,stime FROM Schedule WHERE sdate=@sdate";
            comm.Connection = db;
            var param = factory.CreateParameter();
            param.ParameterName = "@sdate";
            param.Value = e.Day.Date.ToString("yyyy/MM/dd");
            comm.Parameters.Add(param);
            db.Open();
            var reader = comm.ExecuteReader();
            while(reader.Read()) {
                var ltrCr = new LiteralControl("<br />");
                var link = new HyperLink();
                link.NavigateUrl = "Details.aspx?sid=" + reader["sid"];
                link.Text = reader["stime"] + "&nbsp;" + reader["subject"];
                e.Cell.Controls.Add(ltrCr);
                e.Cell.Controls.Add(link);
            }
	        db.Close();
        }
    }

    protected void Page_Load(Object sender, EventArgs e) {
        lblName.Text = Profile.UsrName;
        lblDepart.Text = Profile.DepartName;
    }
</script>

<asp:Content ID="Content1" ContentPlaceHolderID="head" Runat="Server">
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="cph" Runat="Server">
        こんにちは、<asp:Label ID="lblName" runat="server"></asp:Label>
        （<asp:Label ID="lblDepart" runat="server"></asp:Label>
        ）さん！<br />
        <asp:Calendar ID="cal" runat="server" BackColor="#FFFFCC" BorderColor="#FFCC66" 
            BorderWidth="1px" DayNameFormat="Shortest" Font-Names="Verdana" Font-Size="8pt" 
            ForeColor="#663399" Height="375px" ShowGridLines="True" Width="500px" 
            OnDayRender="cal_DayRender">
            <SelectedDayStyle BackColor="#CCCCFF" Font-Bold="True" />
            <SelectorStyle BackColor="#FFCC66" />
            <TodayDayStyle BackColor="#FFCC66" ForeColor="White" />
            <OtherMonthDayStyle ForeColor="#CC9966" />
            <NextPrevStyle Font-Size="9pt" ForeColor="#FFFFCC" />
            <DayHeaderStyle BackColor="#FFCC66" Font-Bold="True" Height="1px" />
            <TitleStyle BackColor="#990000" Font-Bold="True" Font-Size="9pt" 
                ForeColor="#FFFFCC" />
        </asp:Calendar>
</asp:Content>

