﻿<%@ Page Title="FormViewコントロール" Language="C#" MasterPageFile="~/Day02/MyMaster.master" %>

<script runat="server">

    protected void fv_ItemInserting(Object sender, FormViewInsertEventArgs e) {
        if(!Page.IsValid) {
            e.Cancel = true;
        }
    }

    protected void fv_ItemUpdating(Object sender, FormViewUpdateEventArgs e) {
        if(!Page.IsValid) {
            e.Cancel = true;
        }
    }

    protected void fv_ItemInserted(Object sender, FormViewInsertedEventArgs e) {
        Response.Redirect("Calendar.aspx");
    }

    protected void fv_ItemUpdated(Object sender, FormViewUpdatedEventArgs e) {
        Response.Redirect("Calendar.aspx");
    }

    protected void fv_ItemDeleted(Object sender, FormViewDeletedEventArgs e) {
        Response.Redirect("Calendar.aspx");
    }
</script>

<asp:Content ID="Content1" ContentPlaceHolderID="head" Runat="Server">
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="cph" Runat="Server">
    <asp:FormView ID="fv" runat="server" CellPadding="4" DataKeyNames="sid" 
        DataSourceID="sds" EmptyDataText="スケジュール情報がありません。" ForeColor="#333333" 
        HeaderText="スケジュール詳細" OnItemInserting="fv_ItemInserting" OnItemUpdating="fv_ItemUpdating" OnItemInserted="fv_ItemInserted" OnItemUpdated="fv_ItemUpdated" OnItemDeleted="fv_ItemDeleted">
        <FooterStyle BackColor="#990000" Font-Bold="True" ForeColor="White" />
        <RowStyle BackColor="#FFFBD6" ForeColor="#333333" />
        <EditItemTemplate>
            件名:
            <asp:TextBox ID="txtSubject" runat="server" Text='<%# Bind("subject") %>' />
            <asp:RequiredFieldValidator ID="reqSubject" runat="server" 
                ControlToValidate="txtSubject" Display="Dynamic" ErrorMessage="件名は必須です。" 
                SetFocusOnError="True" ValidationGroup="sche">*</asp:RequiredFieldValidator>
            <br />
            日付:
            <asp:TextBox ID="txtSdate" runat="server" 
                Text='<%# Bind("sdate", "{0:yyyy/MM/dd}") %>' />
            <asp:RequiredFieldValidator ID="reqSdate" runat="server" 
                ControlToValidate="txtSdate" Display="Dynamic" ErrorMessage="日付は必須です。" 
                SetFocusOnError="True" ValidationGroup="sche">*</asp:RequiredFieldValidator>
            <asp:CompareValidator ID="cmpSdate" runat="server" ControlToValidate="txtSdate" 
                Display="Dynamic" ErrorMessage="日付はYYYY/MM/DD形式で入力してください。" 
                Operator="DataTypeCheck" SetFocusOnError="True" ValidationGroup="sche" 
                Type="Date">*</asp:CompareValidator>
            <br />
            時刻:
            <asp:TextBox ID="txtStime" runat="server" Columns="10" 
                Text='<%# Bind("stime") %>' />
            <asp:RegularExpressionValidator ID="regStime" runat="server" 
                ControlToValidate="txtStime" Display="Dynamic" 
                ErrorMessage="時刻はHH:MM形式で入力してください。" SetFocusOnError="True" 
                ValidationExpression="[0-9]{2}\:[0-9]{2}" ValidationGroup="sche">*</asp:RegularExpressionValidator>
            <br />
            メモ:
            <asp:TextBox ID="txtMemo" runat="server" Columns="25" 
                Text='<%# Bind("memo") %>' />
            <br />
&nbsp;<asp:Button ID="UpdateButton" runat="server" CommandName="Update" Text="更新" 
                ValidationGroup="sche" />
            <asp:Button ID="UpdateCancelButton" runat="server" CausesValidation="False" 
                CommandName="Cancel" Text="キャンセル" />
        </EditItemTemplate>
        <InsertItemTemplate>
            件名:
            <asp:TextBox ID="txtSubject" runat="server" Text='<%# Bind("subject") %>'></asp:TextBox>
            <asp:RequiredFieldValidator ID="reqSubject" runat="server" ControlToValidate="txtSubject"
                Display="Dynamic" ErrorMessage="件名は必須です。" SetFocusOnError="True" 
                ValidationGroup="sche">*</asp:RequiredFieldValidator><br />
            日付:
            <asp:TextBox ID="txtSdate" runat="server" Text='<%# Bind("sdate", "{0:yyyy年MM月dd日}") %>'></asp:TextBox>
            <asp:RequiredFieldValidator ID="reqSdate" runat="server" ControlToValidate="txtSdate"
                Display="Dynamic" ErrorMessage="日付は必須です。" SetFocusOnError="True" 
                ValidationGroup="sche">*</asp:RequiredFieldValidator>
            <asp:CompareValidator ID="cmpSdate" runat="server" ControlToValidate="txtSdate" ErrorMessage="日付はYYYY/MM/DD形式で入力してください。"
                Operator="DataTypeCheck" SetFocusOnError="True" Type="Date" 
                ValidationGroup="sche" Display="Dynamic">*</asp:CompareValidator><br />
            時刻:
            <asp:TextBox ID="txtStime" runat="server" Columns="10" Text='<%# Bind("stime") %>'></asp:TextBox>
            <asp:RegularExpressionValidator ID="regStime" runat="server" ControlToValidate="txtStime"
                Display="Dynamic" ErrorMessage="時刻はHH:MM形式で入力してください。" SetFocusOnError="True"
                ValidationExpression="[0-9]{2}\:[0-9]{2}" ValidationGroup="sche">*</asp:RegularExpressionValidator><br />
            メモ :
            <asp:TextBox ID="txtMemo" runat="server" Columns="25" Text='<%# Bind("memo") %>'></asp:TextBox><br />
            &nbsp;<br />
            <asp:Button ID="InsertButton" runat="server" CausesValidation="True" CommandName="Insert"
                Text="挿入" ValidationGroup="sche"></asp:Button>
            <asp:Button ID="InsertCancelButton" runat="server" CausesValidation="False" CommandName="Cancel"
                Text="キャンセル"></asp:Button>
        </InsertItemTemplate>
        <ItemTemplate>
            件名:
            <asp:Label ID="lblSubject" runat="server" Text='<%# Bind("subject") %>' />
            <br />
            日付:
            <asp:Label ID="lblSdate" runat="server" 
                Text='<%# Bind("sdate", "{0:yyyy年MM月dd日}") %>' />
            <br />
            時刻:
            <asp:Label ID="lblStime" runat="server" Text='<%# Bind("stime") %>' />
            <br />
            メモ:
            <asp:Label ID="lblMemo" runat="server" Text='<%# Bind("memo") %>' />
            <br />
            <asp:Button ID="EditButton" runat="server" CausesValidation="False" 
                CommandName="Edit" Text="編集" />
            <asp:Button ID="DeleteButton" runat="server" CausesValidation="False" 
                CommandName="Delete" Text="削除" />
            <asp:Button ID="NewButton" runat="server" CausesValidation="False" 
                CommandName="New" Text="新規作成" />
        </ItemTemplate>
        <PagerStyle BackColor="#FFCC66" ForeColor="#333333" HorizontalAlign="Center" />
        <HeaderStyle BackColor="#990000" Font-Bold="True" ForeColor="White" />
    </asp:FormView>
    <asp:SqlDataSource ID="sds" runat="server" ConflictDetection="CompareAllValues" 
        ConnectionString="<%$ ConnectionStrings:MyDB %>" 
        DeleteCommand="DELETE FROM [Schedule] WHERE [sid] = @original_sid AND [subject] = @original_subject AND [sdate] = @original_sdate AND (([stime] = @original_stime) OR ([stime] IS NULL AND @original_stime IS NULL)) AND (([memo] = @original_memo) OR ([memo] IS NULL AND @original_memo IS NULL))" 
        InsertCommand="INSERT INTO [Schedule] ([subject], [sdate], [stime], [memo]) VALUES (@subject, @sdate, @stime, @memo)" 
        OldValuesParameterFormatString="original_{0}" 
        SelectCommand="SELECT [sid], [subject], [sdate], [stime], [memo] FROM [Schedule] WHERE ([sid] = @sid)" 
        UpdateCommand="UPDATE [Schedule] SET [subject] = @subject, [sdate] = @sdate, [stime] = @stime, [memo] = @memo WHERE [sid] = @original_sid AND [subject] = @original_subject AND [sdate] = @original_sdate AND (([stime] = @original_stime) OR ([stime] IS NULL AND @original_stime IS NULL)) AND (([memo] = @original_memo) OR ([memo] IS NULL AND @original_memo IS NULL))">
        <SelectParameters>
            <asp:QueryStringParameter Name="sid" QueryStringField="sid" Type="Int32" />
        </SelectParameters>
        <DeleteParameters>
            <asp:Parameter Name="original_sid" Type="Int32" />
            <asp:Parameter Name="original_subject" Type="String" />
            <asp:Parameter DbType="Date" Name="original_sdate" />
            <asp:Parameter Name="original_stime" Type="String" />
            <asp:Parameter Name="original_memo" Type="String" />
        </DeleteParameters>
        <UpdateParameters>
            <asp:Parameter Name="subject" Type="String" />
            <asp:Parameter DbType="Date" Name="sdate" />
            <asp:Parameter Name="stime" Type="String" />
            <asp:Parameter Name="memo" Type="String" />
            <asp:Parameter Name="original_sid" Type="Int32" />
            <asp:Parameter Name="original_subject" Type="String" />
            <asp:Parameter DbType="Date" Name="original_sdate" />
            <asp:Parameter Name="original_stime" Type="String" />
            <asp:Parameter Name="original_memo" Type="String" />
        </UpdateParameters>
        <InsertParameters>
            <asp:Parameter Name="subject" Type="String" />
            <asp:Parameter DbType="Date" Name="sdate" />
            <asp:Parameter Name="stime" Type="String" />
            <asp:Parameter Name="memo" Type="String" />
        </InsertParameters>
    </asp:SqlDataSource>
    <asp:ValidationSummary ID="sumValid" runat="server" HeaderText="以下のエラーが発生しました。" 
        ShowMessageBox="True" ShowSummary="False" ValidationGroup="sche" />
</asp:Content>

