﻿<%@ Page Title="ObjectDataSourceコントロール" Language="C#" MasterPageFile="~/Day02/MyMaster.master" %>

<script runat="server">
    
    int sum = 0;
    
    protected void grid_RowDataBound(Object sender, GridViewRowEventArgs e) {
        switch(e.Row.RowType) {
            case DataControlRowType.DataRow :
                var crt = (Cart)e.Row.DataItem;
                sum += crt.SubTotal;
                break;
            case DataControlRowType.Footer :
                var sumstr = sum.ToString("#,####円");
                e.Row.Cells[3].Controls.Add(new LiteralControl(sumstr));
                break;
        }
    }

    protected void Page_Load(Object sender, EventArgs e) {
        if(!Page.IsPostBack) {
            txtName.Text = Profile.CustomerName;
            txtAddress.Text = Profile.UserAddress;
        }
    }

    protected void btnOrder_Click(Object sender, EventArgs e) {
        Profile.CustomerName = txtName.Text;
        Profile.UserAddress = txtAddress.Text;
        var crt = new Cart();
        crt.InsertCartInfo();
        Session.Abandon();
        Response.Redirect("ListView.aspx");
    }
</script>

<asp:Content ID="Content1" ContentPlaceHolderID="head" Runat="Server">
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="cph" Runat="Server">
    <asp:GridView ID="grid" runat="server" AutoGenerateColumns="False" 
        Caption="カート精算" CellPadding="4" DataKeyNames="isbn" DataSourceID="ods" 
        EmptyDataText="カートの中身は空です。" ForeColor="#333333" GridLines="None" 
        ShowFooter="True" OnRowDataBound="grid_RowDataBound">
        <RowStyle BackColor="#FFFBD6" ForeColor="#333333" />
        <Columns>
            <asp:BoundField DataField="Title" HeaderText="書名" SortExpression="Title" />
            <asp:BoundField DataField="Price" DataFormatString="{0:#,###円}" HeaderText="単価" 
                HtmlEncode="False" SortExpression="Price" />
            <asp:BoundField DataField="Quantity" HeaderText="購入数" 
                SortExpression="Quantity" />
            <asp:BoundField DataField="SubTotal" DataFormatString="{0:#,###円}" 
                HeaderText="小計" HtmlEncode="False" SortExpression="SubTotal" />
            <asp:CommandField ButtonType="Button" HeaderText="削除" ShowDeleteButton="True" />
        </Columns>
        <FooterStyle BackColor="#990000" Font-Bold="True" ForeColor="White" />
        <PagerStyle BackColor="#FFCC66" ForeColor="#333333" HorizontalAlign="Center" />
        <SelectedRowStyle BackColor="#FFCC66" Font-Bold="True" ForeColor="Navy" />
        <HeaderStyle BackColor="#990000" Font-Bold="True" ForeColor="White" />
        <AlternatingRowStyle BackColor="White" />
    </asp:GridView>
    <asp:ObjectDataSource ID="ods" runat="server" DataObjectTypeName="Cart" 
        DeleteMethod="DeleteCartInfo" SelectMethod="GetCartInfo" TypeName="Cart">
    </asp:ObjectDataSource>
    <br />
    お名前：<br />
    <asp:TextBox ID="txtName" runat="server" Columns="15"></asp:TextBox>
    <br />
    お届け先（都道府県から）：<br />
    <asp:TextBox ID="txtAddress" runat="server" Columns="50"></asp:TextBox>
    <br />
    <br />
    <asp:Button ID="btnOrder" runat="server" Text="注文を確定" OnClick="btnOrder_Click" />
</asp:Content>

