﻿<%@ Application Language="C#" %>
<%@ Import Namespace="System.Web.Routing" %>
<%@ Import Namespace="System.Web.DynamicData" %>

<script RunAt="server">
    public static void RegisterRoutes(RouteCollection routes) {
        MetaModel model = new MetaModel();
        
        //                    重要: データ モデルの登録
        // この行のコメントを解除して、LINQ to SQL クラスや ADO.NET Entity Data モデルを
        // ASP.NET Dynamic Data に対して登録します。ScaffoldAllTables = true のみを設定するのは、
        // すべてのテーブルでスキャフォールディング ビュー (つまりテンプレート化されたビュー) を 
        // サポートする場合です。個別のテーブルのスキャフォールディングを制御するには、 
        // テーブルの部分クラスを作成し、その部分クラスに [Scaffold(true)] 属性を適用します。
        // メモ: 必ず "YourDataContextType" を、使用しているアプリケーションのデータ 
        // コンテキスト クラスの名前に変更してください。
        model.RegisterContext(typeof(AspNet10ExModel.AspNet10ExEntities), new ContextConfiguration() { ScaffoldAllTables = true });

        // 次のステートメントは separate-page モードをサポートします。このモードでは、個別のページを使用して 
        // 一覧表示、詳細表示、挿入、および更新タスクが実行されます。このモードを有効にするには、次の 
        // route 定義のコメントを解除し、後続の combined-page モード セクションの route 定義をコメントにします。
        routes.Add(new DynamicDataRoute("{table}/{action}.aspx") {
            Constraints = new RouteValueDictionary(new { action = "List|Details|Edit|Insert" }),
            Model = model
        });

        // 次のステートメントは combined-page モードをサポートします。このモードでは、同じページを使用して
        // 一覧表示、詳細表示、挿入、および更新タスクが実行されます。このモードを有効にするには、
        // 次の routes 定義のコメントを解除し、前にある separate-page モード セクションの route 定義をコメントにします。
        //routes.Add(new DynamicDataRoute("{table}/ListDetails.aspx") {
        //    Action = PageAction.List,
        //    ViewName = "ListDetails",
        //    Model = model
        //});

        //routes.Add(new DynamicDataRoute("{table}/ListDetails.aspx") {
        //    Action = PageAction.Details,
        //    ViewName = "ListDetails",
        //    Model = model
        //});
    }

    void Application_Start(object sender, EventArgs e) {
        RegisterRoutes(RouteTable.Routes);
    }

</script>
