﻿<%@ Page Title="" Language="VB" MasterPageFile="~/Day02/MyMaster.master" %>

<script runat="server">
    Protected Sub grid_RowCreated(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs)
        If e.Row.RowType = DataControlRowType.Footer Then
            Dim ltr As New LiteralControl("総ページ数：" & grid.PageCount)
            Dim cell As TableCell = e.Row.Cells(e.Row.Cells.Count - 1)
            cell.HorizontalAlign = HorizontalAlign.Right
            cell.Wrap = False
            cell.Controls.Add(ltr)
        End If
    End Sub
</script>

<asp:Content ID="Content1" ContentPlaceHolderID="head" Runat="Server">
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="cph" Runat="Server">
    <asp:GridView ID="grid" runat="server" AllowPaging="True" AllowSorting="True" 
        AutoGenerateColumns="False" CellPadding="4" DataKeyNames="isbn" 
        DataSourceID="sds" ForeColor="#333333" GridLines="None" PageSize="5" 
        ShowFooter="True" OnRowCreated="grid_RowCreated">
        <RowStyle BackColor="#FFFBD6" ForeColor="#333333" />
        <Columns>
            <asp:HyperLinkField DataNavigateUrlFields="isbn" 
                DataNavigateUrlFormatString="http://www.wings.msn.to/index.php/-/A-03/{0}/" 
                DataTextField="isbn" DataTextFormatString="{0}" HeaderText="ISBNコード" />
            <asp:BoundField DataField="title" HeaderText="書名" SortExpression="title" />
            <asp:BoundField DataField="price" HeaderText="価格" 
                SortExpression="price" DataFormatString="{0:#,###円}" HtmlEncode="False" />
            <asp:BoundField DataField="publish" HeaderText="出版社" SortExpression="publish" />
            <asp:BoundField DataField="published" HeaderText="発売日" 
                SortExpression="published" DataFormatString="{0:yyyy年MM月dd日}" 
                HtmlEncode="False" />
            <asp:CheckBoxField DataField="cdrom" HeaderText="CD-ROM" 
                SortExpression="cdrom" />
            <asp:ImageField DataAlternateTextField="title" DataImageUrlField="isbn" 
                DataImageUrlFormatString="http://www.wings.msn.to/books/{0}/{0}.jpg" 
                HeaderText="表紙" ReadOnly="True">
                <ControlStyle Height="48px" Width="35px" />
            </asp:ImageField>
            <asp:CommandField ShowDeleteButton="True" ShowEditButton="True" 
                ButtonType="Button" />
        </Columns>
        <FooterStyle BackColor="#990000" Font-Bold="True" ForeColor="White" />
        <PagerStyle BackColor="#FFCC66" ForeColor="#333333" HorizontalAlign="Center" />
        <SelectedRowStyle BackColor="#FFCC66" Font-Bold="True" ForeColor="Navy" />
        <HeaderStyle BackColor="#990000" Font-Bold="True" ForeColor="White" />
        <AlternatingRowStyle BackColor="White" />
    </asp:GridView>
    <asp:SqlDataSource ID="sds" runat="server" 
        ConnectionString="<%$ ConnectionStrings:MyDB %>" 
        DeleteCommand="DELETE FROM [Book] WHERE [isbn] = @isbn" 
        InsertCommand="INSERT INTO [Book] ([isbn], [title], [price], [publish], [published], [cdrom]) VALUES (@isbn, @title, @price, @publish, @published, @cdrom)" 
        SelectCommand="SELECT [isbn], [title], [price], [publish], [published], [cdrom] FROM [Book]" 
        UpdateCommand="UPDATE [Book] SET [title] = @title, [price] = @price, [publish] = @publish, [published] = @published, [cdrom] = @cdrom WHERE [isbn] = @isbn">
        <DeleteParameters>
            <asp:Parameter Name="isbn" Type="String" />
        </DeleteParameters>
        <UpdateParameters>
            <asp:Parameter Name="title" Type="String" />
            <asp:Parameter Name="price" Type="Int32" />
            <asp:Parameter Name="publish" Type="String" />
            <asp:Parameter DbType="Date" Name="published" />
            <asp:Parameter Name="cdrom" Type="Boolean" />
            <asp:Parameter Name="isbn" Type="String" />
        </UpdateParameters>
        <InsertParameters>
            <asp:Parameter Name="isbn" Type="String" />
            <asp:Parameter Name="title" Type="String" />
            <asp:Parameter Name="price" Type="Int32" />
            <asp:Parameter Name="publish" Type="String" />
            <asp:Parameter DbType="Date" Name="published" />
            <asp:Parameter Name="cdrom" Type="Boolean" />
        </InsertParameters>
    </asp:SqlDataSource>
</asp:Content>

