﻿<%@ Application Language="VB" %>
<%@ Import Namespace="System.Web.Routing" %>
<%@ Import Namespace="System.Web.DynamicData" %>

<script RunAt="server">
Public Shared Sub RegisterRoutes(ByVal routes As RouteCollection)
    Dim model As New MetaModel

    '                     重要: データ モデルの登録
    ' この行のコメントを解除して、LINQ to SQL クラスや ADO.NET Entity Data モデルを
    ' ASP.NET Dynamic Data に対して登録します。ScaffoldAllTables = true のみを設定するのは、
    ' すべてのテーブルでスキャフォールディング ビュー (つまりテンプレート化されたビュー) を 
    ' サポートする場合です。個別のテーブルのスキャフォールディングを制御するには、 
    ' テーブルの部分クラスを作成し、その部分クラスに [Scaffold(true)] 属性を適用します。
    ' メモ: 必ず "YourDataContextType" を、使用しているアプリケーションのデータ 
    ' コンテキスト クラスの名前に変更してください。
        model.RegisterContext(GetType(AspNet10ExModel.AspNet10ExEntities), New ContextConfiguration() With {.ScaffoldAllTables = True})

    ' 次のステートメントは separate-page モードをサポートします。このモードでは、個別のページを使用して 
    ' 一覧表示、詳細表示、挿入、および更新タスクが実行されます。このモードを有効にするには、次の 
    ' route 定義のコメントを解除し、後続の combined-page モード セクションの route 定義をコメントにします。
    routes.Add(New DynamicDataRoute("{table}/{action}.aspx") With { _
        .Constraints = New RouteValueDictionary(New With {.Action = "List|Details|Edit|Insert"}), _
        .Model = model})

    ' 次のステートメントは combined-page モードをサポートします。このモードでは、同じページを使用して
    ' 一覧表示、詳細表示、挿入、および更新タスクが実行されます。このモードを有効にするには、
    ' 次の routes 定義のコメントを解除し、前にある separate-page モード セクションの route 定義をコメントにします。
    'routes.Add(New DynamicDataRoute("{table}/ListDetails.aspx") With { _
    '    .Action = PageAction.List, _
    '    .ViewName = "ListDetails", _
    '    .Model = model})

    'routes.Add(New DynamicDataRoute("{table}/ListDetails.aspx") With { _
    '    .Action = PageAction.Details, _
    '    .ViewName = "ListDetails", _
    '    .Model = model})
End Sub

Private Sub Application_Start(ByVal sender As Object, ByVal e As EventArgs)
    RegisterRoutes(RouteTable.Routes)
End Sub

</script>
